/*
sort_structure.c -- shows simple double sort using qsort
*/
#include <stdlib.h>
#include <stdio.h>

#define MAX 100
struct kpsorter{
	int icount;
	double data;
}recordset[MAX];

int structcomparison(const void *v1, const void *v2);
int real2_cmp(const void *s1, const void *s2);

int main(void)
{
	int i;
	double arr[MAX], arrsort[MAX];
/* Get random integers from the rand() function */
//	kpsorter recordset[MAX];
	srand(17);
	printf("RAND_MAX=%10d\n", RAND_MAX);            /* check operating system limit value */
	for(i=0;i<MAX;i++)
	{
		arr[i] = rand()/((double)RAND_MAX + 1); /* fill arr[,] with random doubles*/
		arrsort[i]=arr[i];
		recordset[i].icount=i;
		recordset[i].data=arr[i];
	}
	qsort(recordset, MAX, sizeof(recordset), structcomparison);
	for(i=0;i<MAX;i++)
	{
		printf("%10d %10d  arr[%10.6f]  arrsort[%10.6f]\n", i, recordset[i].icount, arrsort[i], recordset[i].data);
	}
	printf("\n\n");
	return(0);
}
int structcomparison(const void *v1, const void *v2)
{
	recordset *p1=(recordset *)v1;
	recordset *p2=(recordset *)v2;

	if(p1->data < p2->data)
		return -1;
	else if (p1->data == p2->data)
		return 0;
	else
		return 1;
}
